--declare('PseudoPerlin', PseudoPerlin or {})
PseudoPerlin = {}
math.randomseed( os.time() )

function PseudoPerlin:create_rng(resolution, persistence, octaves)
	local rng = {}
	if resolution == nil then
		rng.resolution = 0.1
	else
		rng.resolution = resolution
	end
	rng.persistence = persistence
	rng.octaves = octaves

	rng.r = {}
	for i=0,rng.octaves-1 do
		local freq = 2^i
		rng.r[i] = SmoothRandom:create_rng(rng.resolution*freq)
	end


	function rng:get()
		local total = 0
		for i=0,self.octaves-1 do
			local amp = persistence^i
			total = total + amp*self.r[i]:get()
		end
		return(total)
	end
	
	return(rng)
end

