function lsd.get_module_ra()
	local ra = lsd.get_module_prototype('ra')
	
	ra.delay = 50

	ra.left_rng = PseudoPerlin:create_rng(0.006, 0.4, 3)
	ra.left_blip_rng = PseudoPerlin:create_rng(0.02, 0.4, 3)
	ra.right_rng = PseudoPerlin:create_rng(0.006, 0.4, 3)
	ra.right_blip_rng = PseudoPerlin:create_rng(0.02, 0.4, 3)
	--ra.leadoff_rng = PseudoPerlin:create_rng(0.02, 0.4, 3)
	ra.crosshair_rng = PseudoPerlin:create_rng(0.01, 0.4, 3)
	
	function ra:get_left()
		return iup.GetBrother(iup.GetParent(HUD.leftradarlabel))
	end

	function ra:get_right()
		return iup.GetBrother(iup.GetParent(HUD.rightradarlabel))
	end

	-- breaks on partial and non absolute size strings
	function ra:iupscale(sizestr, scale)
		local width = sizestr:gmatch("(%d+)")() * scale
		local height = sizestr:gmatch("x(%d+)")() * scale
		return width .. "x" .. height
	end
	
	function ra:action()
		local tmp
		--radar units
		tmp = self.left_rng:get() * 0.6 + 0.4
		self:get_left().size = self:iupscale(self.l, tmp)
		tmp = self.right_rng:get() * 0.6 + 0.4
		self:get_right().size = self:iupscale(self.r, tmp)

		--icons inside radar
		tmp = self.left_blip_rng:get()
		self:get_left().blipscale = tmp * self.lb
		tmp = self.right_blip_rng:get()
		self:get_right().blipscale = tmp * self.rb
		
		--leadoff
		--tmp = self.leadoff_rng:get()
		--HUD.leadoff_arrow.size = self:iupscale(self.leadoff, tmp)
		
		--crosshair
		tmp = self.crosshair_rng:get() * 0.8 + 0.4
		HUD.crosshairlayer[2][2].size = self:iupscale(self.crosshair, tmp)
	end

	function ra:enable_cb()
		self.l = self:get_left().size
		self.lb = self:get_left().blipscale
		self.r = self:get_right().size
		self.rb = self:get_right().blipscale
		--self.leadoff = HUD.leadoff_arrow.size
		self.crosshair = HUD.crosshairlayer[2][2].size
	end

	function ra:disable_cb()
		self:get_left().size = self.l
		self:get_left().blipscale = self.lb
		self:get_right().size = self.r
		self:get_right().blipscale = self.rb
		--HUD.leadoff_arrow.size = self.leadoff
		HUD.crosshairlayer[2][2].size = self.crosshair
	end

	return ra
end

lsd.add_module(lsd.get_module_ra())
