--declare('SmoothRandom', SmoothRandom or {})
SmoothRandom = {}
math.randomseed( os.time() )

function SmoothRandom:create_rng(resolution)
	local rng = {}
	if resolution == nil then
		rng.resolution = 0.1
	else
		rng.resolution = resolution
	end
	rng.position = 0
	rng.r = { math.random(), math.random(), math.random() }

	function rng:interpolate(a, b, frac)
		--return(a + (b-a)*frac) --linear
		return(a + (b-a)*(-2*(frac^3) + 3*(frac^2))) --sort of a cubic interpolation
	end

	function rng:cycle()
		self.r[1] = self.r[2]
		self.r[2] = self.r[3]
		self.r[3] = math.random()
	end

	function rng:update_position()
		self.position = self.position + self.resolution;
		while self.position >= 1 do
			self.position = self.position - 1
			self:cycle()
		end
	end

	function rng:get()
		self:update_position()
		return(self:interpolate(self.r[2], self.r[3], self.position))
	end
	
	return(rng)
end

