--declare('SmoothRandomColor', SmoothRandomColor or {})
SmoothRandomColor = {}

function SmoothRandomColor:create_rng(resolution)
	local rng = {}

	rng.r = SmoothRandom:create_rng(resolution)
	rng.g = SmoothRandom:create_rng(resolution)
	rng.b = SmoothRandom:create_rng(resolution)

	function rng:float_to_byte(f)
		return(math.floor((f*256)%256))
	end

	function rng:random_color_byte(rng)
		return(self:float_to_byte(rng:get()))
	end

	function rng:get()
		local color = {}
		color[0] = self:random_color_byte(self.r)
		color[1] = self:random_color_byte(self.g)
		color[2] = self:random_color_byte(self.b)
		return color
	end

	function rng:get_ascii()
		local color = self:get()
		local ascii = rgbtohex(color[0]..' '..color[1]..' '..color[2])
		return ascii
	end

	return(rng)
end

